#!/bin/sh
if [ -n $1 ]
then
INSTALLDIR=/opt/Canon
else
INSTALLDIR=$1
fi
SANECONFDIR=/etc/sane.d

DEB_HOST_MULTIARCH=`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`
if [ ! $DEB_HOST_MULTIARCH ]
then
        echo "Not support multiarch - Install to /usr/lib64."
        SANELIBDIR=/usr/lib64/sane
else
        if [ -e /usr/lib/$DEB_HOST_MULTIARCH/sane ]
        then
                echo "Support multiarch - Install to /usr/lib/$DEB_HOST_MULTIARCH."
                SANELIBDIR=/usr/lib/$DEB_HOST_MULTIARCH/sane
        else
                echo "Support multiarch but sane directory is legacy - Install to /usr/lib64."
                SANELIBDIR=/usr/lib64/sane
        fi
fi

if [ ! -e $SANECONFDIR/canondr.conf ]
then
	if [ -e $INSTALLDIR/lib/canondr/canondr_com_usb* ]
	then
		rm -f $INSTALLDIR/lib/canondr/canondr_com_usb*
	fi

	if [ -e $INSTALLDIR/lib/canondr/canondr_scannercontrol* ]
	then
		rm -f $INSTALLDIR/lib/canondr/canondr_scannercontrol*
	fi

	if [ -e $INSTALLDIR/lib/sane/libsane-canondr.so.1.0.1 ]
	then
		rm -f $INSTALLDIR/lib/sane/libsane-canondr.so.1.0.1
		rm -f $SANELIBDIR/libsane-canondr.so
		rm -f $SANELIBDIR/libsane-canondr.so.1
		rm -f $SANELIBDIR/libsane-canondr.so.1.0.0
	fi
fi

